package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class RequisicaoPorServicoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaRequisicaoPorServico = By.xpath("//span[text() = 'Requisição por Serviço']");

    //componentes do filtro inicial
    By campoUnidade = By.id("NMFILIAL");
    By unidadeJabaquara = By.xpath("//div[@data-zh-id=\"19777484933696712569481\"]//span[text() = '0002 | DEPOSITO JABAQUARA']");
    By unidadeDepositoBc111 = By.xpath("//div[@data-zh-id=\"19777484933696712569481\"]//span[text() = '0003 | DEPOSITO BC 111']");
    By campoServico = By.id("NMSERVICO");
    By servicoAlmocoEspecial = By.xpath("//div[@data-zh-id=\"19777484934037010406485\"]//span[text() = '00002 | ALMOÇO ESPECIAL']");
    By servicoAlmoco = By.xpath("//div[@data-zh-id=\"19777484934037010406485\"]//span[text() = '00003 | ALMOÇO']");
    By dataFiltro = By.id("DTPREVRETI");
    By botaoAplicarFiltro = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoLimparData = By.xpath("//div[@data-zh-id=\"19777484934206645572492\"]//span[@style=\"background-image: none; display: block;\"]");
    By botalLimparUnidade = By.xpath("//div[@id=\"NMFILIAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"19777484933696712569481\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"19777484934037010406485\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioData = By.xpath("//div[@data-zh-id=\"19777484934206645572492\"]//div[@class=\"zh-validation\"]/span");

    //botões da tela após aplicar o filtro inicial
    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//ul/li[1]");
    By botaoCalcular = By.xpath("//div[@class=\"zh-footer-center\"]//ul/li[2]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]/ul/li");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By abaTipoPratoTelaIni = By.xpath("//div[@class=\"zh-tab-scroller\"]//a[text() = 'Tipo de Prato']");
    By abaProdutoTelaIni = By.xpath("//div[@class=\"zh-tab-scroller\"]//a[text() = 'Produtos']");
    By abaMensagemTelaIni = By.xpath("//div[@class=\"zh-tab-scroller\"]//a[text() = 'Mensagem']");
    By campoMensagem = By.id("DSOBSREQU");

    By campoMensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");

    //componentes de adicionar prato do "tipo de prato"
    By campoTipoPrato = By.id("NMTIPOPRAT");
    By tipoPratoArroz = By.xpath("//div[@data-zh-id=\"19777484932590360782360\"]//span[text() = '01 | ARROZ']");
    By campoPrato = By.id("NMPRATO");
    By pratoArrozTemperado = By.xpath("//div[@data-zh-id=\"19777484933140944423363\"]//span[text() = '00.00.00.000 | ARROZ TEMPEREADO | P']");
    By campoProduto = By.id("NMPRODUTO");
    By produtoOleoAmendoas = By.xpath("//div[@data-zh-id=\"19777484933201277115368\"]//span[text() = '1.01.1.1.01.005.00 | OLEO DE AMENDOAS DOCES | L']");
    By produtoOleoCopaiba = By.xpath("//div[@data-zh-id=\"1977748493730915419407\"]//span[text() = '1.01.1.1.01.003.00 | OLEO DE COPAIBA | L']");
    By campoQuantExtra = By.id("QTPREVEXTRA");
    By campoQuantDevolvida = By.id("QTPREVDEVOL");
    By campoQuantLiberada = By.id("QTPREVLIB");
    By botaoLimparDataLimiteTipoPrato = By.xpath("//div[@data-zh-id=\"19777484931466902255383\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoLimparDataLimiteProduto = By.xpath("//div[@data-zh-id=\"19777484933683937040572\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoData = By.id("DTLIMITERETI");
    By campoHoraLimite = By.id("HRLIMITERETI");
    By scrollHora = By.xpath("//div[@aria-label=\"Hours\"]//div[@class=\"dw-ul\"]");
    By scrollMinuto = By.xpath("//div[@style=\"margin-top: 80px; transition: -webkit-transform 0.1s ease-out 0s; transform: translate3d(0px, -2240px, 0px);\"]//div[@class=\"dw-bf\"][3]");
    By botaoSelecionar = By.xpath("//div[@class=\"dwbw dwb-s\"]");

    //mensagem de campo obrigatório no formulário de adicionar tipo de prato
    By mensagemObrigatorioTipoPrato = By.xpath("//div[@data-zh-id=\"19777484932590360782360\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioPrato = By.xpath("//div[@data-zh-id=\"19777484933140944423363\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProduto = By.xpath("//div[@data-zh-id=\"19777484933201277115368\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDataLimite = By.xpath("//div[@data-zh-id=\"19777484931466902255383\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioHoraLimite = By.xpath("//div[@data-zh-id=\"19777484933239943712385\"]//div[@class=\"zh-validation\"]/span");

    //mensagem de campo obrigatório no formulário de adicionar produto
    By mensagemObrigatorioProdutoFormProduto = By.xpath("//div[@data-zh-id=\"19777484931087234057553\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDataLimiteFormProduto = By.xpath("//div[@data-zh-id=\"19777484933683937040572\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioHoraLimiteFormProduto = By.xpath("//div[@data-zh-id=\"1977748493348020175575\"]//div[@class=\"zh-validation\"]/span");

    //componetes da primeira linha de registro da tela inicial do tipo de prato
    By checkBox = By.xpath("//div[@id=\"grid-19777484933867646281337\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]/span");
    By codTipoPrato = By.xpath("//div[@id=\"grid-19777484933867646281337\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDTIPOPRAT\"]/span");
    By nomeTipoPrato = By.xpath("//div[@id=\"grid-19777484933867646281337\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMTIPOPRAT\"]/span");
    By codPrato = By.xpath("//div[@id=\"grid-19777484933867646281337\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDPRATO\"]/span");
    By nomePrato = By.xpath("//div[@id=\"grid-19777484933867646281337\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRATO\"]/span");

    //componentes do produto que aparecem após clicar no produto do tipo de prato da tela inicial
    By checkBoxProd = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]//span[@data-ng-if=\"!row.__group\"]");
    By checkBoxProdLinha2 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"__CHECKBOX\"]//span[@data-ng-if=\"!row.__group\"]");
    By codTipoPratoProd = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By nomeProdutoProd = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By unidadeProd = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By quantPrevProd = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVRETI\"]/span");
    By quantExtraProd = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVEXTRA\"]/span");
    By quantDevolvidaProd = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVDEVOL\"]/span");
    By quantLiberadaProd = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVLIB\"]/span");
    By mensagemAlertaQuant = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By okAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-ng-repeat=\"button in buttons\"]");
    By mensagemAlertExclusao = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");

    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");

    //para adicionar um produto na requisição "produto", podem ser usados os mesmo componentes da requisição "tipo de prato".
    //os compontes são: campoProduto, campoQuantDevolvida, campoQuantExtra, campoHoraLimite, botaoSelecionar
    By produtoCanfora = By.xpath("//div[@data-zh-id=\"19777484931087234057553\"]//span[text() = '1.01.1.1.02.004.00 | CANFORA | KG']");

    //campos da tela inicial da requisição produto
    By prodCheckBox = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]/span");
    By prodCodigo = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By prodNome = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By prodUnidade = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By prodQuantPrev = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVRETI\"]/span");
    By prodQuantExtra = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVEXTRA\"]/span");
    By prodQuantDevolvida = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVDEVOL\"]/span");
    By prodQuantLiberada = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVLIB\"]/span");

    By botaoRelatorio = By.xpath("//div[@class=\"zh-footer-right\"]");
    By campoRelatorio = By.id("REPORT_NAME");
    By relatorioRequiServico = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//span[text() = 'Requisição por Serviço']");
    By relatorioRequiServicoTurnos = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//span[text() = 'Requisição por Serviço (Turnos)']");
    By relatorioRequiOperador = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//span[text() = 'Requisição por Operador']");
    By relatorioRequiPontoEntregaAnalitico = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//span[text() = 'Requisição por Serviço/Ponto de Entrega (Analítico)']");
    By relatorioGrupoServicoAnalitico = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//span[text() = 'Requisição por Grupo de Serviço (Sintético)']");
    By relatorioRequiServicoTipoPrato = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//span[text() = 'Requisição por Serviço (Tipo de Prato/Prato)']");
    By relatorioRequiUnidadeAdicional = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//span[text() = 'Requisição por Serviço (Unidade Adicional)']");

    By intervaloDataInicial = By.id("DTINTERVAL_START");
    By intervaloDataFinal = By.id("DTINTERVAL_END");
    By campoUnidadeRelatorio = By.id("NMFILIAL");
    By unidadeDepositoBc129 = By.xpath("//div[@data-zh-id=\"211554382920669148555223\"]//span[text() = '9999 | DEPOSITO BC 129']");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-id=\"211554382920669148555223\"]//span[text() = '0002 | DEPOSITO JABAQUARA']");

    By todosGrupoServico = By.xpath("//div[@data-zh-id=\"2115543829150752445231\"]//span[@zh-icon=\"checked no-border\"]");
    By campoGrupoServico = By.id("CDGRUPSERV");
    By grupoServicoGeral = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'GERAL']");
    By grupoServicoPedidos = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'PEDIDOS']");
    By grupoServicoEntregas = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'ENTREGAS']");
    By todosServicos = By.xpath("//div[@data-zh-id=\"211554382933141150795238\"]//span[@zh-icon=\"checked no-border\"]");
    By campoServicoRelatorio = By.id("NMSERVICO");
    By servicoAlmocoEspecialRel = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'ALMOÇO ESPECIAL']");
    By servicoSolicitacao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'SOLICITACAO']");
    By servicoDistribuicao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'DISTRIBUICAO']");
    By checkBoxTodosPontoEntrega = By.id("zh-checkbox-Todos_Ptentrega");
    By todosPontoEntrega = By.xpath("//div[@data-zh-id=\"211554382922530837345245\"]//span[@zh-icon=\"checked no-border\"]");
    By campoPontoEntrega = By.id("NMPTENTREGA");
    By pontoEntregaTeknisa = By.xpath("//div[@data-zh-field-name=\"NMPTENTREGA\"]//span[text() = 'TEKNISA']");
    By todosTipoConsumo = By.xpath("//div[@data-zh-id=\"21155438293623644711599\"]//span[@zh-icon=\"checked no-border\"]");
    By campoTipoConsumo = By.id("IDConsumo");
    By tipoMateriaPrima = By.xpath("//div[@data-zh-field-name=\"NMConsumo\"]//span[text() = 'Matéria Prima']");
    By tipoConsumoFixo = By.xpath("//div[@data-zh-field-name=\"NMConsumo\"]//span[text() = 'Consumo Fixo']");
    By tipoConsumoPerCapita = By.xpath("//div[@data-zh-field-name=\"NMConsumo\"]//span[text() = 'Consumo Per Capita']");

    By botaoOkTelasDeOpoes = By.xpath("//section[@class='popup-container']//div[@class='zh-footer-right']");

    By botaoLimparRelatorio = By.xpath("//div[@id=\"REPORT_NAME\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoLimparDatasRelatorio = By.xpath("//div[@id=\"DTINTERVAL\"]//span[@zh-icon=\"no-border close-x\"]");
    By botaoLimparUnidadeRelatorio = By.xpath("//div[@id=\"NMFILIAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By mensagemObrigatorioRelatorio = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDatasRelatorio = By.xpath("//div[@data-zh-id=\"21155438294223570727518\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidadeRelatorio = By.xpath("//div[@data-zh-id=\"211554382920669148555223\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioGrupoServicoRelatorio = By.xpath("//div[@data-zh-id=\"211554382923833651125227\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServicoRelatorio = By.xpath("//div[@data-zh-id=\"211554382936927568765233\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioPontoEntrega = By.xpath("//div[@data-zh-id=\"21155438296736465565240\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioTipoConsumo = By.xpath("//div[@data-zh-id=\"21155438293051913602597\"]//div[@class=\"zh-validation\"]/span");

    By botaoImprimirCardapio = By.xpath("//label[@for=\"zh-checkbox-IDIMPRIMECARD\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By botaoArredondarQuant = By.xpath("//label[@for=\"zh-checkbox-ARREDQTD\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By botaoImprimirLinhaBranco = By.xpath("//label[@for=\"zh-checkbox-LINHABR\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");

    By ordenacaoCodigo = By.xpath("//label[@for=\"radio-ORDENACAO-Código\"]//div[@class=\"zh-circle mousetrap zh-ripple-effect\"]");
    By ordenacaoAlfabetica = By.xpath("//label[@for=\"radio-ORDENACAO-Alfabética Pelo Nível\"]//div[@class=\"zh-circle mousetrap zh-ripple-effect\"]");
    By campoNivel = By.xpath("//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By nivel5 = By.xpath("//div[@data-zh-id=\"211554382928063106915260\"]//li[@data-value=\"5\"]");

    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@contenteditable='true']");
    By botaoConfirmar = By.xpath("//section[@class='popup-container']//span[text() = 'Confirmar']");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Requisição por Serviço");
        click(telaRequisicaoPorServico);
    }

    public void preencherFiltroIni(String tipoRequisicao) {
        if (tipoRequisicao == "Tipo de Prato") {
            clicarCampoSelecionarValor(campoUnidade, unidadeJabaquara);
            clicarCampoSelecionarValor(campoServico, servicoAlmocoEspecial);

        } else if (tipoRequisicao == "Produto") {
            clicarCampoSelecionarValor(campoUnidade, unidadeDepositoBc111);
            clicarCampoSelecionarValor(campoServico, servicoAlmoco);
        }
        click(botaoLimparData);
        click(dataFiltro);
        sendKeys(dataFiltro, "17/08/2022");
        tempo();
        click(botaoAplicarFiltro);
    }

    public void preencherFiltroIniParaCalcular() {
        clicarCampoSelecionarValor(campoUnidade, unidadeJabaquara);
        clicarCampoSelecionarValor(campoServico, servicoAlmocoEspecial);
        click(botaoLimparData);
        click(dataFiltro);
        sendKeys(dataFiltro, "01/09/2022");
        tempo();
        click(botaoAplicarFiltro);
        tempo();
    }

    public void calcularRequisicao() {
        click(botaoCalcular);
        String mensagemEsperada = "Este processo apagará os produtos inseridos manualmente! Deseja recalcular a requisição?";
        String mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem que aparece na tela após clicar no botão calcular");
        click(botaoSim);
    }

    //preencher formulário para cadastrar um tipo de prato
    public void preencherFormTipoPrato() {
        tempo();
        tempo();
        click(botaoAdicionar);

        clicarCampoSelecionarValor(campoTipoPrato, tipoPratoArroz);
        clicarCampoSelecionarValor(campoPrato, pratoArrozTemperado);
        clicarCampoSelecionarValor(campoProduto, produtoOleoAmendoas);
        sendKeys(campoQuantExtra, "8");
        sendKeys(campoQuantDevolvida, "5");
        click(campoQuantExtra);

        click(campoHoraLimite);
        sendKeys(campoHoraLimite, "08:00");
//        click(botaoSelecionar);
        click(botaoSalvar);
    }

    //tentar salvar o formulário com os campos vazios, para validar se os mesmos são obrigatórios
    public void verificarMensObrigaFormTipoPrato() {
        tempo();
        tempo();
        click(botaoAdicionar);
        click(botaoLimparDataLimiteTipoPrato);
        click(botaoSalvar);

        String tipoPrato = getText(mensagemObrigatorioTipoPrato);
        String prato = getText(mensagemObrigatorioPrato);
        String produto = getText(mensagemObrigatorioProduto);
        String dataLimite = getText(mensagemObrigatorioDataLimite);
        String horaLimite = getText(mensagemObrigatorioHoraLimite);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(tipoPrato, mensagemEsperada, "Verificação da mensagem de obrigatório no campo tipo de prato do formulário do tipo de prato");
        Assert.assertEquals(prato, mensagemEsperada, "Verificação da mensagem de obrigatório no campo prato do formulário do tipo de prato");
        Assert.assertEquals(produto, mensagemEsperada, "Verificação da mensagem de obrigatório no campo produto do formulário do tipo de prato");
        Assert.assertEquals(dataLimite, mensagemEsperada, "Verificação da mensagem de obrigatório no campo data limite do formulário do tipo de prato");
        Assert.assertEquals(horaLimite, mensagemEsperada, "Verificação da mensagem de obrigatório no campo hora limite do formulário do tipo de prato");
    }

    //selecionar os campos que são osbrigatórios do formulário tipo de prato
    public void selecionarCamposObrigatoriosFormTipoPrato() {
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(campoTipoPrato), -200, 0).click().build().perform();
        click(tipoPratoArroz);

        actions.moveToElement(driver.findElement(campoPrato), -200, 0).click().build().perform();
        click(pratoArrozTemperado);

        actions.moveToElement(driver.findElement(campoProduto), -200, 0).click().build().perform();
        click(produtoOleoAmendoas);

        actions.moveToElement(driver.findElement(campoData), -200, 0).click().build().perform();
        tempo();
        sendKeys(campoData, "17/08/2022");

        sendKeys(campoQuantExtra, "7");
        sendKeys(campoQuantDevolvida, "2");
        click(campoQuantExtra);
        actions.moveToElement(driver.findElement(campoHoraLimite), -200, 0).click().build().perform();
        sendKeys(campoHoraLimite, "07:00");
//        click(botaoSelecionar);
        click(botaoSalvar);
    }

    //preencher formulário para cadastrar um tipo de prato.
    public void preencherFormProduto() {
        tempo();
        tempo();
        click(botaoAdicionar);
        tempo();
        clicarCampoSelecionarValor(campoProduto, produtoCanfora);
        sendKeys(campoQuantExtra, "8");
        sendKeys(campoQuantDevolvida, "6,5");

        click(campoHoraLimite);
        sendKeys(campoHoraLimite, "07:30");
        click(botaoSalvar);
    }

    //verificar se os dados adicionados no formulário de tipo de prato foram salvos e estão aparecendo corretamente na tela inicial
    public void verificarTipoPratoAdd() {

        //valores encontrados
        String encCodigoTipo = getText(codTipoPrato);
        String enctipoPrato = getText(nomeTipoPrato);
        String encCodigoPrato = getText(codPrato);
        String encPrato = getText(nomePrato);

        //valores esperados
        String expCodigoTipo = "01";
        String exptipoPrato = "ARROZ";
        String expCodigoPrato = "00.00.00.000";
        String expPrato = "ARROZ TEMPEREADO";

        Assert.assertEquals(encCodigoTipo, expCodigoTipo, "Valor esperado do código após adicionar o primeiro tipo");
        Assert.assertEquals(enctipoPrato, exptipoPrato, "Valor esperado do tipo de prato após adicionar o primeiro tipo");
        Assert.assertEquals(encCodigoPrato, expCodigoPrato, "Valor esperado do código do prato após adicionar o primeiro tipo");
        Assert.assertEquals(encPrato, expPrato, "Valor esperado do prato após adicionar o primeiro tipo");
    }

    //verificar campos obrigatórios do filtro inicial
    public void verificarCamposObrigFiltroInicial() {
        click(botalLimparUnidade);
        click(botaoLimparData);
        click(botaoAplicarFiltro);

        //mensagem de campo obrigatório encontrada nos componentes
        String unidade = getText(mensagemObrigatorioUnidade);
        String servico = getText(mensagemObrigatorioServico);
        String data = getText(mensagemObrigatorioData);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'unidade' do filtro da tela inicial");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'serviço' do filtro da tela inicial");
        Assert.assertEquals(data, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'data' do filtro da tela inicial");

        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(campoUnidade), -200, 0).click().build().perform();
        click(unidadeJabaquara);
        tempo();
        actions.moveToElement(driver.findElement(campoServico), -400, 0).click().build().perform();
        click(servicoAlmocoEspecial);
        tempo();
        actions.moveToElement(driver.findElement(dataFiltro), -150, 0).click().build().perform();
        sendKeys(dataFiltro, "17/08/2022");
        tempo();
        click(botaoAplicarFiltro);
        tempo();
        click(botaoAdicionar);
    }

    //verificar se os dados do produto adicionado na requisição de produto, foram salvos corretamente
    public void verificarProdutoAdd() {
        //valores encontrados
        String encCodigo = getText(prodCodigo);
        String encNomeProd = getText(prodNome);
        String encUnidade = getText(prodUnidade);
        String encQuantPrev = getText(prodQuantPrev);
        String encQuantExtra = getText(prodQuantExtra);
        String encQuantDevolvida = getText(prodQuantDevolvida);
        String encQuantLiberada = getText(prodQuantLiberada);

        //valores esperados
        String expCodigo = "1.01.1.1.02.004.00";
        String expNomeProd = "CANFORA";
        String expUnidade = "KG";
        String expQuantPrev = "0,000";
        String expQuantExtra = "8,000";
        String expQuantDevolvida = "6,500";
        String expQuantLiberada = "1,500";

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código do produto adicionado");
        Assert.assertEquals(encNomeProd, expNomeProd, "Verificação do nome do produto adicionado");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação da unidade do produto adicionado");
        Assert.assertEquals(encQuantPrev, expQuantPrev, "Verificação da quantidade previsata do produto adicionado");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificação da quantidade extra do produto adicionado");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificação da quantidade devolvida do produto adicionado");
        Assert.assertEquals(encQuantLiberada, expQuantLiberada, "Verificação da quantidade liberada do produto adicionado");
    }

    //tentar salvar o formulário com os campos vazios, para validar se os mesmos são obrigatórios
    public void verificarMensObrigaFormProduto() {
        tempo();
        click(botaoAdicionar);
        click(botaoLimparDataLimiteProduto);
        click(botaoSalvar);

        String produto = getText(mensagemObrigatorioProdutoFormProduto);
        String dataLimite = getText(mensagemObrigatorioDataLimiteFormProduto);
        String horaLimite = getText(mensagemObrigatorioHoraLimiteFormProduto);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(produto, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo 'produto' no formulário de produto");
        Assert.assertEquals(dataLimite, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo 'data limite' no formulário de produto");
        Assert.assertEquals(horaLimite, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo 'hora limite' no formulário de produto");
    }

    //alterar a quantidade extra e devolvida e verificar se os valores estão corretos
    public void editarQuantidadeProd() {
        //Obs: não estava sendo possível automatizar a alterações do valoros na primeira tela do produto. Será necessário clicar no mesmo para fazer às alterações
        click(nomePrato);
        click(nomeProdutoProd);

        clear(campoQuantExtra);
        sendKeys(campoQuantExtra, "6");
        Actions actions = new Actions(driver);
        actions.sendKeys(Keys.ENTER);

        String mensagem = getText(mensagemAlertaQuant);
        String mensagemAlert = "A quantidade devolvida deve ser menor ou igual a soma das quantidades prevista e extra.";
        Assert.assertEquals(mensagem, mensagemAlert, "Mensagem alerta por adicionar uma quantidade extra com o valor menor que a devolvida");
        click(okAlerta);

        clear(campoQuantDevolvida);
        sendKeys(campoQuantDevolvida, "5");
        click(botaoSalvar);
    }

    //verificar dados do produtos após edição da quantidade
    public void verificarEdicaoProd() {
        //valores encontrados
        String encCodigo = getText(codTipoPratoProd);
        String encNomeProd = getText(nomeProdutoProd);
        String encUnidade = getText(unidadeProd);
        String encQuantPrevista = getText(quantPrevProd);
        String encQuantExtra = getText(quantExtraProd);
        String encQuantDevolvida = getText(quantDevolvidaProd);
        String encQuantLiberada = getText(quantLiberadaProd);

        //valores esperados
        String expCodigo = "1.01.1.1.01.005.00";
        String expNomeProd = "OLEO DE AMENDOAS DOCES";
        String expUnidade = "L";
        String expQuantPrevista = "0,000";
        String expQuantExtra = "6,000";
        String expQuantDevolvida = "5,000";
        String expQuantLiberada = "1,000";

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código encontrado após edição das quantidades");
        Assert.assertEquals(encNomeProd, expNomeProd, "Verificação do nome encontrado após edição das quantidades");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação do unidade encontrado após edição das quantidades");
        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificação do quantidade precista encontrado após edição das quantidades");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificação do quantidade devolvida encontrado após edição das quantidades");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificação do quantidade liberada encontrado após edição das quantidades");
        Assert.assertEquals(encQuantLiberada, expQuantLiberada, "Verificação do código encontrado após edição das quantidades");
    }

    //verificar os campos obrigatório da tela de relatórios
    public void verificarObrigatorioTelaRelatorio() {
        tempo();
        click(botaoRelatorio);
        click(botaoLimparRelatorio);
        click(botaoLimparDatasRelatorio);
        click(botaoLimparUnidadeRelatorio);
        click(todosGrupoServico);
        click(todosServicos);
        click(todosTipoConsumo);
        click(botaoRelatorio);

        //mensagens de campo obrigatório encontradas
        String relatorio = getText(mensagemObrigatorioRelatorio);
        String intervaloDatas = getText(mensagemObrigatorioDatasRelatorio);
        String unidade = getText(mensagemObrigatorioUnidadeRelatorio);
        String grupoServico = getText(mensagemObrigatorioGrupoServicoRelatorio);
        String servico = getText(mensagemObrigatorioServicoRelatorio);
        String tipoConsumo = getText(mensagemObrigatorioTipoConsumo);

        String mensagemEsperada = "Campo obrigatório";
        String mensagemEsperadaDatas = "Start and End date is Required!";
        Assert.assertEquals(relatorio, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo relatório");
        Assert.assertEquals(intervaloDatas, mensagemEsperadaDatas, "Verificação da mensagem de campo obrigatório no campo intervalo de datas");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo unidade");
        Assert.assertEquals(grupoServico, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo grupo de serviço");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo serviço");
        Assert.assertEquals(tipoConsumo, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo tipo de consumo");

        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(campoRelatorio), -200, 0).click().build().perform();
        click(relatorioRequiPontoEntregaAnalitico);
        click(todosPontoEntrega);
        click(botaoRelatorio);
        String pontoEntrega = getText(mensagemObrigatorioPontoEntrega);
        Assert.assertEquals(pontoEntrega, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo ponto de entrega");
    }

    //adicionar um novo produto após clicar no tipo de prato da tela inicial
    public void adicionarProd() {
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoProduto, produtoOleoCopaiba);
        sendKeys(campoQuantExtra, "8");
        sendKeys(campoQuantDevolvida, "6");
        click(campoHoraLimite);
        click(botaoSelecionar);
        click(botaoSalvar);
    }

    /*verificar produto adicionado. O primeiro produto será removido, pois assim não será necessário mapear todos os campos da segunda linha, podem ser usados
    os componentes da primeira linha*/
    public void verificarProdAdd() {
        tempo();
        click(checkBoxProdLinha2);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlertExclusao);
        String mensagemExclusao = "Confirma exclusão do(s) produto(s) selecionado(s)?";
        Assert.assertEquals(mensagem, mensagemExclusao, "Verificação da mensagem de alerta para exclusão do produto");
        click(botaoSim);

        //valores encontrados
        String encCodigo = getText(codTipoPratoProd);
        String encNomeProd = getText(nomeProdutoProd);
        String encUnidade = getText(unidadeProd);
        String encQuantPrevista = getText(quantPrevProd);
        String encQuantExtra = getText(quantExtraProd);
        String encQuantDevolvida = getText(quantDevolvidaProd);
        String encQuantLiberada = getText(quantLiberadaProd);

        //valores esperados
        String expCodigo = "1.01.1.1.01.003.00";
        String expNomeProd = "OLEO DE COPAIBA";
        String expUnidade = "L";
        String expQuantPrevista = "0,000";
        String expQuantExtra = "8,000";
        String expQuantDevolvida = "6,000";
        String expQuantLiberada = "2,000";

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código encontrado após edição das quantidades");
        Assert.assertEquals(encNomeProd, expNomeProd, "Verificação do nome encontrado após edição das quantidades");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação do unidade encontrado após edição das quantidades");
        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificação do quantidade precista encontrado após edição das quantidades");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificação do quantidade devolvida encontrado após edição das quantidades");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificação do quantidade liberada encontrado após edição das quantidades");
        Assert.assertEquals(encQuantLiberada, expQuantLiberada, "Verificação do código encontrado após edição das quantidades");
    }

    //editar quantidades do produto, na requisição de produos
    public void editarQuantProduto() {
        click(prodNome);

        clear(campoQuantExtra);
        sendKeys(campoQuantExtra, "6");
        Actions actions = new Actions(driver);
        actions.sendKeys(Keys.ENTER);

        String mensagem = getText(mensagemAlertaQuant);
        String mensagemAlert = "A quantidade devolvida deve ser menor ou igual a soma das quantidades prevista e extra.";
        Assert.assertEquals(mensagem, mensagemAlert, "Mensagem alerta por adicionar uma quantidade extra com o valor menor que a devolvida");
        click(okAlerta);

        clear(campoQuantDevolvida);
        sendKeys(campoQuantDevolvida, "5");
        click(botaoSalvar);
    }

    public void inserirMensagem(String tipoRequisicao) {
        tempo();
        tempo();
        click(abaMensagemTelaIni);
        clear(campoMensagem);
        sendKeys(campoMensagem, "Mensagem para o tipo de prato");
        click(botaoSalvar);
        if (tipoRequisicao == "Tipo de Prato") {
            click(abaTipoPratoTelaIni);

        } else if (tipoRequisicao == "Produto") {
            click(abaProdutoTelaIni);
        }
        click(abaMensagemTelaIni);

        tempo();
        clear(campoMensagem);
        sendKeys(campoMensagem, "Mensagem editada para o tipo de prato");
        click(botaoSalvar);
        tempo();

        if (tipoRequisicao == "Tipo de Prato") {
            click(abaTipoPratoTelaIni);

        } else if (tipoRequisicao == "Produto") {
            click(abaProdutoTelaIni);
        }

        //não está sendo possível fazer a verificação da mensagem que foi salva
//        String mensagem = javaScriptExecutor.executeScript("document.querySelector(\"#DSOBSREQU\").value").toString();
//        Assert.assertEquals(mensagem, "Mensagem para o tipo de prato", "Verificação da mensagem adicionada");
//        clear(campoMensagem);
//        sendKeys(campoMensagem, "Mensagem editada para o tipo de prato");
//        click(botaoSalvar);
//        mensagem = getText(campoMensagem);
//        Assert.assertEquals(mensagem, "Mensagem editada para o tipo de prato", "Verificação da mensagem editada adicionada");
    }

    public void limparCampoMensagem(String tipoRequisicao) {
        tempo();
        tempo();
        click(abaMensagemTelaIni);
        clear(campoMensagem);
        click(botaoSalvar);
        if (tipoRequisicao == "Tipo de Prato") {
            click(abaTipoPratoTelaIni);

        } else if (tipoRequisicao == "Produto") {
            click(abaProdutoTelaIni);
        }
    }

    public void excluirTipoPrato() {
        tempo();
        click(checkBox);
        click(botaoExcluir);

        String msgAlerta = getText(campoMensagemAlerta);
        String mensagem = "Confirma exclusão do(s) prato(s) selecionado(s)?";
        Assert.assertEquals(msgAlerta, mensagem, "Verificação da mensagem de alerta da exclusão do tipo de prato");
        click(botaoSim);
    }

    public void excluirProduto() {
        tempo();
        click(prodCheckBox);
        click(botaoExcluir);

        String msgAlerta = getText(campoMensagemAlerta);
        String mensagem = "Confirma exclusão do(s) produto(s) selecionado(s)?";
        Assert.assertEquals(msgAlerta, mensagem, "Verificação da mensagem de alerta da exclusão do tipo de prato");
        click(botaoSim);
    }

    public void acessarTelaRelatorio() {
        tempo();
        click(botaoRelatorio);
    }

    public void selecionarRelatorio(String nomeRelatorio) {
//        tempo();
//        click(botaoRelatorio);

        if (nomeRelatorio == "Requisição por Serviço") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioRequiServico);
        } else if (nomeRelatorio == "Requisição por Serviço (Turnos)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioRequiServicoTurnos);
        } else if (nomeRelatorio == "Requisição por Operador") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioRequiOperador);
        } else if (nomeRelatorio == "Requisição por Serviço/Ponto de Entrega (Analítico)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioRequiPontoEntregaAnalitico);
        } else if (nomeRelatorio == "Requisição por Grupo de Serviço (Sintético)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioGrupoServicoAnalitico);
        } else if (nomeRelatorio == "Requisição por Serviço (Tipo de Prato/Prato)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioRequiServicoTipoPrato);
        } else if (nomeRelatorio == "Requisição por Serviço (Unidade Adicional)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioRequiUnidadeAdicional);
        }

    }

    public void preencherDatas(String dataInicial, String dataFinal) {
        super.preencherDatas(intervaloDataInicial, intervaloDataFinal, dataInicial, dataFinal);
    }

    public void selecionarUnidadeDepositoJabaquara() {
        click(botaoLimparUnidadeRelatorio);
        clicarCampoSelecionarValor(campoUnidadeRelatorio, unidadeDepositoJabaquara);
    }

    public void selecionarGrupoServico() {
        click(todosGrupoServico);
        click(campoGrupoServico);
        click(grupoServicoGeral);
        click(grupoServicoPedidos);
        click(grupoServicoEntregas);
        click(botaoOkTelasDeOpoes);
    }

    public void selecionarServicos() {
        click(todosServicos);
        click(campoServico);
        click(servicoAlmocoEspecialRel);
//        click(servicoSolicitacao);
//        click(servicoDistribuicao);
        click(botaoOkTelasDeOpoes);
    }

    public void selecionarTipoConsumo() {
        click(todosTipoConsumo);
        click(campoTipoConsumo);
        click(tipoMateriaPrima);
        click(tipoConsumoFixo);
        click(tipoConsumoPerCapita);
        click(botaoOkTelasDeOpoes);
    }

    public void selecionarCaracteristicasRelatorio(String nomeRelatorio) {
        if (nomeRelatorio == "Requisição por Serviço/Ponto de Entrega (Analítico)") {
            click(botaoImprimirCardapio);
        } else {
            click(botaoImprimirCardapio);
            click(botaoArredondarQuant);
            click(botaoImprimirLinhaBranco);
        }
    }

    public void selecionarOrdenacao(String ordenacao) {
        if (ordenacao == "Código") {
            click(ordenacaoCodigo);
        } else if (ordenacao == "Alfabética Pelo Nível") {
            click(ordenacaoAlfabetica);
            click(campoNivel);
            click(nivel5);
        }
    }

    public void selecionarPontoEntrega(String nomeRelatorio) {
        if (nomeRelatorio == "Requisição por Serviço/Ponto de Entrega (Analítico)") {
            click(todosPontoEntrega);
            click(campoPontoEntrega);
            click(pontoEntregaTeknisa);
            click(botaoOkTelasDeOpoes);
        }
    }

    public void gerarRelatorio() {
        click(botaoRelatorio);
        click(tipoPdf);
        click(botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    //    relatorioRequiServico = Requisição por Serviço *
    //    relatorioRequiServicoTurnos = Requisição por Serviço (Turnos) *
    //    relatorioRequiOperador = Requisição por Operador *
    //    relatorioRequiPontoEntregaAnalitico = Requisição por Serviço/Ponto de Entrega (Analítico) *
    //    relatorioGrupoServicoAnalitico = Requisição por Grupo de Serviço (Sintético) *
    //    relatorioRequiServicoTipoPrato = Requisição por Serviço (Tipo de Prato/Prato) *
    //    relatorioRequiUnidadeAdicional = Requisição por Serviço (Unidade Adicional)

    public void verificarCampoPontoEntrega() {
        List<String> relatoriosList = new ArrayList<>();
        relatoriosList.add("Requisição por Serviço");
        relatoriosList.add("Requisição por Serviço (Turnos)");
        relatoriosList.add("Requisição por Operador");
        relatoriosList.add("Requisição por Serviço/Ponto de Entrega (Analítico)");
        relatoriosList.add("Requisição por Grupo de Serviço (Sintético)");
        relatoriosList.add("Requisição por Serviço (Tipo de Prato/Prato)");
        relatoriosList.add("Requisição por Serviço (Unidade Adicional)");

        for (String relatorio : relatoriosList) {
            selecionarRelatorio(relatorio);
            boolean todosPontoEntrega = returnIfElementIsEnabled(checkBoxTodosPontoEntrega);

            if (relatorio == "Requisição por Serviço/Ponto de Entrega (Analítico)") {
                Assert.assertEquals(todosPontoEntrega, true, "Verificação se a opção 'todos' do campo ponto de " +
                        "entrega está habilitado com o relatório: " + relatorio);
            } else {
                Assert.assertEquals(todosPontoEntrega, false, "Verificação se a opção 'todos' do campo ponto de " +
                        "entrega está habilitado com o relatório " + relatorio);
            }

        }
    }


}
